<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>

    <groupId>com.lanyuanxiaoyao</groupId>
    <artifactId>hudi-service</artifactId>
    <version>1.0.0-SNAPSHOT</version>
    <packaging>pom</packaging>
    <modules>
        <module>service-common</module>
        <module>service-dependencies</module>
        <module>service-configuration</module>
        <module>service-forest</module>
        <module>utils/executor</module>
        <module>service-api</module>
        <module>service-check</module>
        <module>service-cli</module>
        <module>service-cloud-query</module>
        <module>service-command</module>
        <module>service-executor</module>
        <module>service-exporter</module>
        <module>service-flink-query</module>
        <module>service-gateway</module>
        <module>service-hudi-query</module>
        <module>service-info-query</module>
        <module>service-launcher</module>
        <module>service-loki-query</module>
        <module>service-monitor</module>
        <module>service-pulsar-query</module>
        <module>service-queue</module>
        <module>service-scheduler</module>
        <module>service-uploader</module>
        <module>service-web</module>
        <module>service-yarn-query</module>
        <module>service-zookeeper-query</module>
        <module>utils/sync</module>
    </modules>

    <properties>
        <maven.compiler.source>8</maven.compiler.source>
        <maven.compiler.target>8</maven.compiler.target>
        <project.build.sourceEncoding>UTF-8</project.build.sourceEncoding>

        <build-tag>b2b12</build-tag>

        <spring-boot.version>2.6.8</spring-boot.version>
        <spring-cloud.version>2021.0.3</spring-cloud.version>
        <flink.major.version>1.13</flink.major.version>
        <scala.major.version>2.11</scala.major.version>
        <hudi.version>0.12.0-eshore-SNAPSHOT</hudi.version>
        <flink.version>1.13.3</flink.version>
        <hadoop.version>1.13.3</hadoop.version>
        <eclipse-collections.version>10.4.0</eclipse-collections.version>
        <curator.version>5.1.0</curator.version>
        <pulsar.version>2.8.0</pulsar.version>
        <hutool.version>5.7.16</hutool.version>
    </properties>

    <profiles>
        <profile>
            <id>b2a4</id>
            <properties>
                <build-tag>b2a4</build-tag>
            </properties>
        </profile>
        <profile>
            <id>b2b1</id>
            <properties>
                <build-tag>b2b1</build-tag>
            </properties>
        </profile>
        <profile>
            <id>b2b5</id>
            <properties>
                <build-tag>b2b5</build-tag>
            </properties>
        </profile>
        <profile>
            <id>b2b12</id>
            <properties>
                <build-tag>b2b12</build-tag>
            </properties>
        </profile>
    </profiles>

    <dependencyManagement>
        <dependencies>
            <!-- 当前项目依赖 -->
            <dependency>
                <groupId>com.lanyuanxiaoyao</groupId>
                <artifactId>service-common</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>com.lanyuanxiaoyao</groupId>
                <artifactId>service-configuration</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>com.lanyuanxiaoyao</groupId>
                <artifactId>service-dependencies</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>com.lanyuanxiaoyao</groupId>
                <artifactId>service-forest</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>com.lanyuanxiaoyao</groupId>
                <artifactId>service-cli-core</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>com.lanyuanxiaoyao</groupId>
                <artifactId>service-executor-core</artifactId>
                <version>${project.version}</version>
            </dependency>
            <dependency>
                <groupId>com.lanyuanxiaoyao</groupId>
                <artifactId>executor</artifactId>
                <version>${project.version}</version>
            </dependency>

            <!-- spring boot 相关依赖 -->
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-dependencies</artifactId>
                <version>${spring-boot.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <dependency>
                <groupId>org.springframework.cloud</groupId>
                <artifactId>spring-cloud-dependencies</artifactId>
                <version>${spring-cloud.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <dependency>
                <groupId>com.dtflys.forest</groupId>
                <artifactId>forest-spring-boot-starter</artifactId>
                <version>1.5.30</version>
            </dependency>
            <dependency>
                <groupId>com.alibaba</groupId>
                <artifactId>druid-spring-boot-starter</artifactId>
                <version>1.2.17</version>
            </dependency>
            <dependency>
                <groupId>com.fasterxml.jackson.datatype</groupId>
                <artifactId>jackson-datatype-eclipse-collections</artifactId>
                <version>2.13.5</version>
            </dependency>
            <dependency>
                <groupId>com.github.ulisesbocchio</groupId>
                <artifactId>jasypt-spring-boot-starter</artifactId>
                <version>3.0.4</version>
            </dependency>

            <!-- 命令行工具 -->
            <dependency>
                <groupId>org.springframework.shell</groupId>
                <artifactId>spring-shell-starter</artifactId>
                <version>2.1.0-M3</version>
            </dependency>
            <dependency>
                <groupId>me.tongfei</groupId>
                <artifactId>progressbar</artifactId>
                <version>0.9.3</version>
            </dependency>

            <!-- 日志 -->
            <dependency>
                <groupId>pl.tkowalcz.tjahzi</groupId>
                <artifactId>logback-appender</artifactId>
                <version>0.9.23</version>
            </dependency>
            <dependency>
                <groupId>com.github.loki4j</groupId>
                <artifactId>loki-logback-appender-jdk8</artifactId>
                <version>1.4.2</version>
            </dependency>
            <dependency>
                <groupId>org.apache.httpcomponents</groupId>
                <artifactId>httpclient</artifactId>
                <version>4.5.13</version>
            </dependency>

            <!-- 增强工具 -->
            <dependency>
                <groupId>io.github.dragons96</groupId>
                <artifactId>sql-builder</artifactId>
                <version>0.0.5.3</version>
            </dependency>
            <dependency>
                <groupId>dev.failsafe</groupId>
                <artifactId>failsafe</artifactId>
                <version>3.2.4</version>
            </dependency>
            <dependency>
                <groupId>org.eclipse.collections</groupId>
                <artifactId>eclipse-collections</artifactId>
                <version>${eclipse-collections.version}</version>
                <scope>runtime</scope>
            </dependency>
            <dependency>
                <groupId>org.eclipse.collections</groupId>
                <artifactId>eclipse-collections-api</artifactId>
                <version>${eclipse-collections.version}</version>
            </dependency>
            <dependency>
                <groupId>cn.hutool</groupId>
                <artifactId>hutool-all</artifactId>
                <version>${hutool.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.pulsar</groupId>
                <artifactId>pulsar-client</artifactId>
                <version>${pulsar.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.pulsar</groupId>
                <artifactId>pulsar-client-admin</artifactId>
                <version>${pulsar.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.hadoop</groupId>
                <artifactId>hadoop-client</artifactId>
                <version>3.1.2</version>
            </dependency>
            <dependency>
                <groupId>io.juicefs</groupId>
                <artifactId>juicefs-hadoop</artifactId>
                <version>2.0.0</version>
            </dependency>
            <dependency>
                <groupId>org.apache.parquet</groupId>
                <artifactId>parquet-format</artifactId>
                <version>2.4.0</version>
            </dependency>
            <dependency>
                <groupId>com.cronutils</groupId>
                <artifactId>cron-utils</artifactId>
                <version>9.2.0</version>
            </dependency>
            <dependency>
                <groupId>com.sun.jersey</groupId>
                <artifactId>jersey-client</artifactId>
                <version>1.19.4</version>
            </dependency>
            <dependency>
                <groupId>com.sun.jersey</groupId>
                <artifactId>jersey-core</artifactId>
                <version>1.19.4</version>
            </dependency>
            <dependency>
                <groupId>com.sun.jersey.contribs</groupId>
                <artifactId>jersey-apache-client4</artifactId>
                <version>1.19.4</version>
            </dependency>

            <!-- Flink 运行时 -->
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-java</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-streaming-java_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-clients_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-table-common</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-table-runtime-blink_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-table-planner-blink_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.hudi</groupId>
                <artifactId>hudi-flink${flink.major.version}-bundle</artifactId>
                <version>${hudi.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-metrics-prometheus_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-core</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-runtime_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-runtime-web_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-optimizer_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-streaming-scala_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-metrics-core</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-container_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-yarn_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-hadoop-fs</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-table-uber_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-table-uber-blink_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-state-processor-api_${scala.major.version}</artifactId>
                <version>${flink.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-shaded-guava</artifactId>
                <version>18.0-13.0</version>
            </dependency>
            <dependency>
                <groupId>org.apache.flink</groupId>
                <artifactId>flink-shaded-hadoop-3-uber</artifactId>
                <version>3.1.1.7.2.9.0-173-9.0</version>
            </dependency>
            <dependency>
                <groupId>org.apache.curator</groupId>
                <artifactId>curator-recipes</artifactId>
                <version>${curator.version}</version>
            </dependency>
            <dependency>
                <groupId>org.apache.curator</groupId>
                <artifactId>curator-framework</artifactId>
                <version>${curator.version}</version>
            </dependency>
        </dependencies>
    </dependencyManagement>

    <build>
        <pluginManagement>
            <plugins>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-source-plugin</artifactId>
                    <version>3.3.0</version>
                </plugin>
                <plugin>
                    <groupId>org.apache.maven.plugins</groupId>
                    <artifactId>maven-shade-plugin</artifactId>
                    <version>3.3.0</version>
                </plugin>
                <plugin>
                    <groupId>org.springframework.boot</groupId>
                    <artifactId>spring-boot-maven-plugin</artifactId>
                    <version>${spring-boot.version}</version>
                </plugin>
            </plugins>
        </pluginManagement>
    </build>

    <distributionManagement>
        <repository>
            <id>${releases.id}</id>
            <name>${releases.name}</name>
            <url>${releases.url}</url>
        </repository>
        <snapshotRepository>
            <id>${snapshots.id}</id>
            <name>${snapshots.name}</name>
            <url>${snapshots.url}</url>
        </snapshotRepository>
    </distributionManagement>

</project>